/*Copyright (C) 1999 by Heinz Haeberle, heinz.haeberle@gmx.net

This is a RTLinux-module for C200-based CAN-cards. It supports now
the Phytec CAN-card on Irq 7, IO 0x100+0x120 (2 ports version)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.*/

#ifndef bool 
#define bool int
#endif

/*  Adress-Offset's der CAN-Register  */

#define  C200_CTRL         0
#define  C200_CMND         1
#define  C200_STS          2
#define  C200_INTER        3
#define  C200_ACCC         4
#define  C200_ACCM         5
#define  C200_BT0          6
#define  C200_BT1          7
#define  C200_OUT_CTRL     8
#define  C200_TEST         9
#define  C200_TXDB1        10
#define  C200_TXDB2        11
#define  C200_TXDATA0      12
#define  C200_RXDB1        20
#define  C200_RXDB2        21
#define  C200_RXDATA0      22
#define  C200_RXDATA1      23
#define  C200_RXDATA2      24
#define  C200_RXDATA3      25
#define  C200_RXDATA4      26
#define  C200_RXDATA5      27
#define  C200_RXDATA6      28
#define  C200_RXDATA7      29
#define  C200_DUMMY        30
#define  C200_CLOCK_DIV    31


/*  Bedeutung der Bits im CAN-Control-Register  */

#define  CR_RR          0x01            /*  Reset Request  */
#define  CR_RIE         0x02            /*  Receive Interrupt Enable  */
#define  CR_TIE         0x04            /*  Transmit Interrupt Enable  */
#define  CR_EIE         0x08            /*  Error Interrupt Enable  */
#define  CR_OIE         0x10            /*  Overrun Interrupt Enable  */
#define  CR_S           0x40            /*  Synch  */

/*  Bedeutung der Bits im CAN-Command-Register  */

#define  CMR_TR         0x01            /*  Transmission Request  */
#define  CMR_AT         0x02            /*  Abort Transmission  */
#define  CMR_RRB        0x04            /*  Release Receive Buffer  */
#define  CMR_COS        0x08            /*  Clear Overrun Status  */
#define  CMR_GTS        0x10            /*  Sleep- und Wake-up-Bit */

/*  Bedeutung der Bits im CAN-Status-Register  */
#define  SR_RBS         0x01            /*  Receive Buffer Status  */
#define  SR_DO          0x02            /*  Data Overrun  */
#define  SR_TBA         0x04            /*  Transmit Buffer Access  */
#define  SR_TCS         0x08            /*  Transmit Complete Status  */
#define  SR_RS          0x10            /*  Receive Status  */
#define  SR_TS          0x20            /*  Transmit Status  */
#define  SR_ES          0x40            /*  Error Status  */
#define  SR_BS          0x80            /*  Bus Status  */

/*  Bedeutung der Bits im CAN-Interrupt-Register  */
#define  IR_RI          0x01            /*  Receive Interrupt  */
#define  IR_TI          0x02            /*  Transmit Interrupt  */
#define  IR_EI          0x04            /*  Error Interrupt  */
#define  IR_OI          0x08            /*  Overrun Interrupt  */
#define  IR_WUI         0x10            /*  Wake-Up Interrupt  */

/* DSCRRegister */
#define DSCR2_RTR         0x10  /* Bitnummer des remoteflags im DSR2 */
#define DSCR2_DLC         0x0f  /* Bereuch des DLC */

/*  Weitere nuetzliche Makros fuer den Anwender  */
#define  C2RTR_FLAG      0x10
#define  C200_CAN_BUS_OFF        (C200_CAN_RD(C200_STS) & SR_BS)   /*  CAN im Bus-Off ?  */
#define  C200_CAN_ERROR_STATUS   (C200_CAN_RD(C200_STS) & SR_ES)   /*  CAN im Error-Status ?  */
#define  C200_DATA_OVERRUN       (C200_CAN_RD(C200_STS) & SR_DO)   /*  Data Overrun ?  */


