/*Copyright (C) 1999 by Heinz Haeberle, heinz.haeberle@gmx.net

This is a RTLinux-module for C200-based CAN-cards. It supports now
the Phytec CAN-card on Irq 7, IO 0x100+0x120 (2 ports version)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.*/

#ifndef __CANDRV_H__
#define __CANDRV_H__
typedef struct {
	unsigned short id;
	unsigned short port;
	char           datalen;	// datalen > 8 or < 0 means remoteframe
	unsigned char  data[8];
} sCanMsg;

typedef int (*CANFunction)(sCanMsg*);

// return 0 on success
int CANWrite(int port, int id, int len, unsigned char *data);

// registers a function which should be called back if this
// id is recieved return 0 on success
int CANAddCallbackFn(int port, int id, CANFunction);

// removes a prefies added function from the callbacklist
int CANRemCallbackFn(int port, int id);
#endif //__CANDRV_H__