/*Copyright (C) 1999 by Heinz Haeberle, heinz.haeberle@gmx.net
This is a testprogram for the RTL-module candrv

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.*/

#include <stdio.h>
#include <sys/ioctl.h>
#include <linux/isdn.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <pthread.h>
#include "candrv.h"
void *sendtask(void *dummy)
{
    sCanMsg canmsg;
    int fdsend=(int)dummy;
    canmsg.port = 0; canmsg.id = 0;
    canmsg.datalen = 2;
    canmsg.data[0] = 1;
    canmsg.data[1] = 0;
    while(1)
    {
	canmsg.data[0] = canmsg.data[0] == 1 ? 2 : 1;
	if (sizeof(canmsg) != write(fdsend, &canmsg, sizeof(canmsg)))
		printf("Message not sent\n");
	usleep(500000);	
    }
}

void *recvtask(void *dummy)
{
	int i;
	int fdrecv=(int)dummy;
	sCanMsg canmsg;
	while(1)
	{
		if (read(fdrecv, &canmsg, sizeof(canmsg)) == sizeof(canmsg))
		{
			printf("recv: %i %03x", canmsg.port,canmsg.id);
			if ((canmsg.datalen < 0) || (canmsg.datalen > 8))
			{
				printf("REMOTE\n");
			} 
			else
			{
				for(i=0;i<canmsg.datalen;i++)
					printf(" %02x",canmsg.data[i]);
				printf("\n");
			}
		}
	}
}

int main()
{
	int i,fdsend,fdrecv;
	int len,port,id;
	int bi[8];
	char Buffer[50];
	sCanMsg canmsg;
	pthread_t	recvtaskid;
	pthread_t	sendtaskid;
	
	fdrecv = open("/dev/rtf0",O_RDWR | O_CREAT/*|O_NONBLOCK*/);
	fdsend = open("/dev/rtf1",O_RDWR | O_CREAT/*|O_NONBLOCK*/);
	if ((fdsend<0) || (fdrecv<0))
	{
		printf("can't open /dev/rtf0|1  maybe the driver isn't loaded\n");
		exit (-1);
	}
	if (pthread_create(&recvtaskid, NULL, recvtask, (void*)fdrecv))
	{
		printf("can't create thread!\n");
		exit (-2);
	}
#if 0	
	if (pthread_create(&sendtaskid, NULL, sendtask, (void*)fdsend))
	{
		printf("can't create thread!\n");
		exit (-2);
	}
#endif
	printf(	"You can send messages over CAN with this tool\n"
			"This is the syntax for sending a message:\n"
			"<Interface> <CAN-ID> [byte0 [Byte1 [byte2 ...\n"
			"everything have is interpreted as hex\n"
			"Example: '0 201 55' to send 1 byte with 0x55\n"
			"                    over interface 0 to ID 0x201\n"
			"type 'quit' to exit the program\n");
	while(1)
	{
		int rc;
		if (fgets(Buffer,sizeof(Buffer)-1,stdin))
		{
			if (strncasecmp("quit", Buffer, 4) == 0)
				break;
			len = sscanf(Buffer, "%i %x %x %x %x %x %x %x %x %x", &port, &id,
						&bi[0],&bi[1],&bi[2],&bi[3],&bi[4],&bi[5],&bi[6],&bi[7]);
			if (len < 2)
//				return -1;			
				continue;
			canmsg.port = (unsigned short)port;
			canmsg.id   = (unsigned short)id;
			if (bi[0] < 0)
				canmsg.datalen = -1;
			else
				canmsg.datalen = len -2;
			for (i=0;i<canmsg.datalen;i++)
				canmsg.data[i] = bi[i];
			if (sizeof(canmsg) == write(fdsend, &canmsg, sizeof(canmsg)))
				printf("Message sent\n");
		}			
		else
			printf("rc(read) =%i\n",rc);
//		usleep(1000000);
	}
	close(fdsend);
	return 0;
}
