#include <linux/module.h>
#include <linux/kernel.h>
#include <asm/io.h>
#include <rtl.h>
#include <rtl_fifo.h>
#include <time.h>
#include <rtl_sched.h>
#include <rtl_sync.h>
#include <rtl_time.h>
#include <rtl_debug.h>
#include <string.h>

#define USERSPACERECVDFIFO	1


pthread_t threadsend,threadtest;
typedef struct testbuffer
{
    char b[14];
}testbuffer ;

static void *sendtask(void *dummy)
{
	testbuffer tb;
	int tries,ret; 
	pthread_make_periodic_np(pthread_self(),gethrtime(),1000*10000);
	while(1)
	{
		int i;
		ret = rtf_get(USERSPACERECVFIFO,&tb,sizeof());
		rtl_printf(" %i\n",ret);
		pthread_wait_np();           
	}		
	return NULL;
}

int fifoHandler(unsigned int fifo)
{
	if (fifo == USERSPACESENDFIFO)
	{
		pthread_wakeup_np (threadsend);
		return 0;
	}
	else
		return -EINVAL;
}

static void *testtask(void *dummy)
{
    testbuffer tb;
    pthread_make_periodic_np(pthread_self(),gethrtime(),10000*10000);
//    breakpoint();
    while(1)
    {
	rtf_put(USERSPACESEENDFIFO,tb,sizeof(tb));
	pthread_wait_np();           
    }
}

int init_module(void)
{
	int i;
	pthread_attr_t attr;
	struct sched_param sched_param;
	int thread_status;
	rtf_create(INTERNALRECVFIFO,1000);
	pthread_attr_init (&attr);
	sched_param.sched_priority = 1;
	pthread_attr_setschedparam (&attr, &sched_param);
	rtl_printf("About to thread create\n");
	thread_status = pthread_create (&threadsend,  &attr, sendtask, (void *)1);
	if (thread_status != 0) {
		rtl_printf("failed to create RT-thread; errno=\n", errno);
		return -1;
	} else {
 		rtl_printf("created RT-thread\n"); 
	}
	rtl_printf("About to thread create\n");
	thread_status = pthread_create (&threadtest,  &attr, testtask, (void *)1);
	if (thread_status != 0) {
		rtl_printf("failed to create RT-thread; errno=\n", errno);
		return -1;
	} else {
 		rtl_printf("created RT-thread\n"); 
	}
	return 0;
}


void cleanup_module(void)
{
	int i;
	pthread_delete_np (threadsend);
	pthread_delete_np (threadtest);
	rtf_destroy(INTERNALRECVFIFO);
	rtl_printf ("Removing module on CPU %d\n", rtl_getcpuid());
}
