/***************************************************************************
                          error.h  -  description
                             -------------------
    begin                : Mon Jul 17 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivanmr@altavista.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ERROR_H
#define ERROR_H


/**
  *@author Ivan Martinez
  */

#include <string>

class CCodeGenerator;

class CError {
public:
	/** Constructor */
	CError();

	/** Destructor */
	~CError();

	/** Returns the error number */
	unsigned int Number() const;

	/** Returns the error's location */
	const CCodeGenerator* Location() const;

	/** Returns the error message */
	const string Message() const;

	/** Sets the error number */
	void SetNumber(unsigned int);

	/** Sets the error's location */
	void SetLocation(const CCodeGenerator*);
private:
	/** Error's location */
	const CCodeGenerator* m_pLocation;

	/** Error number */
	unsigned int m_uNumber;
};

#endif
