/***************************************************************************
                          variable.h  -  description
                             -------------------
    begin                : Fri Feb 11 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivanmr@altavista.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VARIABLE_H
#define VARIABLE_H

#include "codegenerator.h"

/**
  *@author Ivan Martinez
  */

class CVariable : public CCodeGenerator {
public:
	/** Constructor */
	CVariable();

	/** Destructor */
	~CVariable();

	/** Returns TRUE if the argument is "CVariable" or "CCodeGenerator",
		otherwise FALSE */
	virtual bool DescendantOf(const string&) const;

	/** Returns the type of the variable */
	const string& Type() const;
protected:

	/** Generates the error 601 if there is any other component in the
		same container with the	value Identifier() as name */
	virtual void ComponentsDependingArrange(void* = NULL);

	/** Generates the static local declaration of the variable */
	virtual void GenerateLocalDeclarations(ostream&, void* = NULL) const;

	/** If the first argument is not this component, the second is
		"variable name" and the third is Identifier(), returns TRUE meaning
		that there is a repetition of variable names in the scope. If not,
		calls the function with the same arguments in the contained components
		and returns if one of the calls returned TRUE. */
	virtual bool RepeatedValue(const CCodeGenerator*, const string&,
		const string&) const;

	/** Sets the type of the variable */
	void SetType(const string&);
private: // Private attributes

	/** Type of the variable */
	string m_Type;
};

#endif
