/***************************************************************************
                          function.cpp  -  description
                             -------------------
    begin                : Tue Feb 15 2000
    copyright            : (C) 2000 by 
    email                : ivanmr@altavista.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "function.h"

#include "loop.h"
#include "dynamicsystem.h"

CFunction::CFunction()
{
	m_Code = "";
}
CFunction::~CFunction()
{
}

string CFunction::Class() const
{
	return "CFunction";
}

bool CFunction::DescendantOf(const string& ClassNameL) const
{
	if (ClassNameL == "CFunction")
		return true;
	else
		return CBlock::DescendantOf(ClassNameL);
}

//Del by KDevelop: void CFunction::GenerateBlockCode(ostream& StreamL) const
//Del by KDevelop: {
//Del by KDevelop: }

bool CFunction::SetCode(const string& Code)
{
	m_Code = Code;

	return true;
}

const string& CFunction::Code() const
{
	return m_Code;
}

//Del by KDevelop: void CFunction::GenerateCode(ostream& Stream, const CCodeGenerator* pCaller,
//Del by KDevelop: 	const string& Section, void* ExtraParameter = NULL) const
//Del by KDevelop: {
//Del by KDevelop: 	if (pCaller->DescendantOf("CDynamicSystem"))
//Del by KDevelop: 	{
//Del by KDevelop: 		if (Section == "initialization functions declaration")
//Del by KDevelop: 			GenerateInitializationFunctions(Stream, ExtraParameter);
//Del by KDevelop: 		else
//Del by KDevelop: 			if (Section == "initialization functions call")
//Del by KDevelop: 				GenerateInitializationCall(Stream, ExtraParameter);
//Del by KDevelop: 			else
//Del by KDevelop: 				if (Section == "functions declaration")
//Del by KDevelop: 					GenerateFunctions(Stream, ExtraParameter);
//Del by KDevelop: 	}
//Del by KDevelop: 	else
//Del by KDevelop: 		if (pCaller->DescendantOf("CLoop"))
//Del by KDevelop: 			if (Section == "processes call")
//Del by KDevelop: 				GenerateCall(Stream, ExtraParameter);
//Del by KDevelop: }

//Del by KDevelop: void CFunction::GenerateInitializationCall(ostream& Stream,
//Del by KDevelop: 	void* ExtraParameter = NULL) const
//Del by KDevelop: {
//Del by KDevelop: 	Stream << "  " << Container()->Identifier() << "_" << Name() <<
//Del by KDevelop: 		"_vars_init();" << endl;
//Del by KDevelop: }

//Del by KDevelop: void CFunction::GenerateInitializationFunctions(ostream& Stream,
//Del by KDevelop: 	void* ExtraParameter = NULL) const
//Del by KDevelop: {
//Del by KDevelop: 	Stream << "void " << Container()->Identifier() << "_" << Name() <<
//Del by KDevelop: 		"_vars_init(void)" << endl;
//Del by KDevelop: 	Stream << "{" << endl;
//Del by KDevelop: 
//Del by KDevelop: 	ComponentsGenerateCode(Stream, "initialized variables declaration", ExtraParameter);
//Del by KDevelop: 	ComponentsGenerateCode(Stream, "variables initialization", ExtraParameter);
//Del by KDevelop: 	ComponentsGenerateCode(Stream, "initialized variables writing", ExtraParameter);
//Del by KDevelop: 
//Del by KDevelop: 	Stream << "}" << endl;
//Del by KDevelop: }

bool CFunction::LoopVariablesAccess() const
{
	return true;
}

bool CFunction::SystemVariablesAccess() const
{
	return true;
}

bool CFunction::LocalIOVariablesAccess() const
{
	return true;
}

void CFunction::GenerateFunctions(ostream& Stream,
	void* pExtraParameter = NULL) const
{
	CStringsSet StringsSet;

	Stream << "void " << Identifier() << "(void)" <<	endl;
	Stream << "{" << endl;

	StringsSet.clear();
	Container()->Container()->ComponentsGenerateCode(StringsSet, this,
		"flags declaration", pExtraParameter);
	copy(StringsSet.begin(), StringsSet.end(),
		ostream_iterator<string>(Stream, "\n"));
	Container()->Container()->ComponentsGenerateCode(Stream, this,
		"local system variable declarations", pExtraParameter);
	Container()->ComponentsGenerateCode(Stream, this,
		"local loop variable declarations", pExtraParameter);
	ComponentsGenerateCode(Stream, "local IO variables declaration",
		pExtraParameter);
	ComponentsGenerateCode(Stream, "block variables declaration",
		pExtraParameter);

	Container()->Container()->ComponentsGenerateCode(Stream, this,
		"system variables reading", pExtraParameter);
	Container()->ComponentsGenerateCode(Stream, this,
		"loop variables reading", pExtraParameter);
	ComponentsGenerateCode(Stream, "inputs reading", pExtraParameter);
	ComponentsGenerateCode(Stream, "block variables reading",
		pExtraParameter);

	Stream << Code() << endl;

	ComponentsGenerateCode(Stream, "block variables writing",
		pExtraParameter);
	ComponentsGenerateCode(Stream, "outputs writing", pExtraParameter);
	Container()->ComponentsGenerateCode(Stream, this,
		"loop variables writing", pExtraParameter);
	Container()->Container()->ComponentsGenerateCode(Stream, this,
		"system variables writing", pExtraParameter);

	Stream << "}" << endl;
}
