/***************************************************************************
                          output.cpp  -  description
                             -------------------
    begin                : Mon Mar 27 2000
    copyright            : (C) 2000 by 
    email                : ivanmr@altavista.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "output.h"

#include "block.h"
#include "loop.h"

COutput::COutput()
{
}

COutput::~COutput()
{
}

void COutput::Arrange(void *pExtraParameter = NULL)
{
	if (IllegalCIdentifier(Identifier()))
		AddError(600);
	else
		if (IllegalCIdentifier(Type()))
			AddError(602);
		else
			SetGlobalIdentifier("iovar_" + Container()->Container()->Identifier() +
				"_" +	Container()->Name() + "_" + Identifier());
}

bool COutput::DescendantOf(const string& ClassNameL) const
{
	if (ClassNameL == "COutput")
		return true;
	else
		return CDualVariable::DescendantOf(ClassNameL);
}

const CBlock* COutput::Container() const
{
	return (CBlock*)CVariable::Container();
}

const string& COutput::Name() const
{
	return Identifier();
}

bool COutput::SetName(const string& Name)
{
	SetIdentifier(Name);

	if (IllegalCIdentifier(Name))
	{
		AddError(600);
		return false;
	}	
	else
		return true;
}

void COutput::GenerateCode(ostream& Stream, const CCodeGenerator* pCaller,
	const string& Section, void* pExtraParameter = NULL) const
{
	if (pCaller->DescendantOf("CDynamicSystem"))
	{
		if (Section == "global variables declaration")
			GenerateGlobalDeclarations(Stream, pExtraParameter);
	}
	else
		if (pCaller->DescendantOf("CBlock"))
			if (Section == "local IO variables declaration")
				GenerateLocalDeclaration(Stream, pExtraParameter);
			else			
				if (Section == "outputs writing")
					GenerateGlobalWriting(Stream, pExtraParameter);
}

//Del by KDevelop: bool COutput::SetType(const string& Type)
//Del by KDevelop: {
//Del by KDevelop: 	CVariable::SetType(Type);
//Del by KDevelop: 
//Del by KDevelop: 	if (IllegalCIdentifier(Type))
//Del by KDevelop: 	{
//Del by KDevelop: 		AddError(602);
//Del by KDevelop: 		return false;
//Del by KDevelop: 	}	
//Del by KDevelop: 	else
//Del by KDevelop: 		return true;
//Del by KDevelop: }

//Del by KDevelop: bool COutput::AcceptsContainer(const CCodeGenerator* pContainer)
//Del by KDevelop: {
//Del by KDevelop: 	if (pContainer->DescendantOf("CBlock"))
//Del by KDevelop: 	{
//Del by KDevelop: 		SetContainer(pContainer);
//Del by KDevelop: 		return true;
//Del by KDevelop: 	}
//Del by KDevelop: 	else
//Del by KDevelop: 	{
//Del by KDevelop: 		AddError(101);
//Del by KDevelop: 		return false;
//Del by KDevelop: 	}
//Del by KDevelop: }

//Del by KDevelop: string COutput::Class() const
//Del by KDevelop: {
//Del by KDevelop: 	return "COutput";
//Del by KDevelop: }
