/***************************************************************************
                          settingsharedmemory.h  -  description
                             -------------------
    begin                : Tue Feb 13 2001
    copyright            : (C) 2001 by Ivan Martinez
    email                : ivanmr@altavista.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SETTINGSHAREDMEMORY_H
#define SETTINGSHAREDMEMORY_H

#include "variablesharedmemory.h"

/**
  *@author Ivan Martinez
  */

class CInitializableVariable;

class CSettingSharedMemory : public CVariableSharedMemory  {
public:
	/** Constructor */
	CSettingSharedMemory();
	
	/** Destructor */
	~CSettingSharedMemory();

	/** If the paramater is not DescendantOf("CInitializableVariable"),
		generates the error 101 and returns false. If it is, but the container
		already contains a setting shared memory, generates the error 2600 and
		returns	false. Otherwise sets the parameter as the container of this
		component and returns true */
	virtual bool AcceptsContainer(const CCodeGenerator*);

	/** Returns "CSettingSharedMemory" */
	virtual string Class() const;

	/** Returns the container of this component */
	const CInitializableVariable* Container() const;
protected: // Protected methods
	/** Calls a code generation function depending on the arguments */
	virtual void GenerateCode(ostream&, const CCodeGenerator*, const string&,
		void* = NULL) const;

	/** Sets the identifier, type and size of the shared data and the lock
		that prevents concurrent access to it, and the kernel memory pointer
		as a pointer to a global variable */
	virtual void Arrange(void* = NULL);

	/** Generates shared memory reading into the global variable preventing
		concurrent access of such variable */
	virtual void GenerateLockedMemoryReading(ostream&, void* = NULL) const;
};

#endif
