/***************************************************************************
                          variablefifo.cpp  -  description
                             -------------------
    begin                : Thu Jul 6 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivanmr@altavista.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "variablefifo.h"

CVariableFifo::CVariableFifo()
{
}
CVariableFifo::~CVariableFifo()
{
}

void CVariableFifo::GenerateLoopDeclarations(CStringsSet& StringsSet,
	void* pExtraParameter = NULL) const
{
	if (Container()->DescendantOf("CSystemVariable"))
		StringsSet.insert("  static unsigned long flags;");
}

void CVariableFifo::GenerateCode(CStringsSet& StringsSet,
	const CCodeGenerator* pCaller, const string& Section,
	void* pExtraParameter = NULL) const
{
	if (pCaller->DescendantOf("CDynamicSystem"))
	{
		if (Section == "includes")
			GenerateIncludes(StringsSet, pExtraParameter);
	}
	else
		if (pCaller->DescendantOf("CLoop"))
			if (Section == "local variables declaration")
				GenerateLoopDeclarations(StringsSet, pExtraParameter);
}
