/***************************************************************************
                          variablefifo.h  -  description
                             -------------------
    begin                : Thu Jul 6 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivanmr@altavista.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VARIABLEFIFO_H
#define VARIABLEFIFO_H

#include "rtfifo.h"

/**
  *@author Ivan Martinez
  */

class CVariableFifo : public CRTFifo  {
public:
	/** Constructor */
	CVariableFifo();

	/** Destructor */
	~CVariableFifo();
protected: // Protected methods
	/** Calls a code generation function depending on the arguments.
		Lines repeated in the same section are eliminated */
	virtual void GenerateCode(CStringsSet&, const CCodeGenerator*,
		const string&, void* = NULL) const;

	/** Generates the declaration of the lock that prevents concurrent
		access to the global variable */
	virtual void GenerateLoopDeclarations(CStringsSet&, void* = NULL) const;
  /**  */

};

#endif
