/***************************************************************************
                          variablesharedmemory.h  -  description
                             -------------------
    begin                : Fri Feb 16 2001
    copyright            : (C) 2001 by Ivan Martinez
    email                : ivanmr@altavista.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VARIABLESHAREDMEMORY_H
#define VARIABLESHAREDMEMORY_H

#include "protectedsharedmemory.h"

/**
  *@author Ivan Martinez
  */

class CVariableSharedMemory : public CProtectedSharedMemory  {
public:
	/** Constructor */
	CVariableSharedMemory();

	/** Destructor */	
	~CVariableSharedMemory();
	
	/** Sets the offset of the shared memory in the shared memory pool */
	bool SetOffset(off_t);

	/** Returns the offset of the shared memory in the shared memory pool */
	off_t Offset() const;
protected: // Protected methods
	/** Generates the acquisition of the lock that prevents concurrent
		access to the shared data */
	virtual void GenerateLockAcquisition(ostream&, void* = NULL) const;
	
	/** Generates the release of the lock that prevents concurrent access
		to the shared data */
	virtual void GenerateLockRelease(ostream&, void* = NULL) const;

	/** Generates shared memory and lock initialization */
	virtual void GenerateInitialization(ostream&, void* = NULL) const;
  /**  */
  virtual void GenerateLoopDeclarations(CStringsSet&, void* = NULL) const;
  /**  */
  virtual void GenerateCode(CStringsSet&, const CCodeGenerator*, const string&, void* = NULL) const;
};

#endif
