/***************************************************************************
                          comediinput.cpp  -  description
                             -------------------
    begin                : Tue Mar 6 2001
    copyright            : (C) 2001 by Ivan Martinez
    email                : ivanmr@altavista.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <comediinput.h>

CComediInput::CComediInput()
{
	CFixedOutput* Output;
	
	Output = new CFixedOutput(this);
	Output->SetName("output");
	AddFixedComponent(Output);
}

CComediInput::~CComediInput()
{
}

string CComediInput::Class() const
{
	return "CComediInput";
}

bool CComediInput::DescendantOf(const string & ClassName) const
{
	if (ClassName == "CComediInput")
		return true;
	else
		return CComediChannel::DescendantOf(ClassName);
}

void CComediInput::GenerateFunctions(ostream& Stream,
	void* pExtraParameter) const
{
	CStringsSet StringsSet;

	Stream << "void " << Identifier() << "(void)" <<	endl;
	Stream << "{" << endl;
	Stream << "  static lsampl_t data;" << endl;

	Stream << "  comedi_data_read(" << ComediMinor() << ", " <<
		ComediSubdevice() << ", " << ComediChannel() << ", " << ComediRange() <<
		", " << ComediReference() << ", &data);" << endl;
	Stream << "  " << Output()->GlobalIdentifier() <<
		" = (((float) data) / " <<	MaximumData() << " * " << Range() <<
		") + " << Offset() << ";" << endl;

	Stream << "}" << endl;
}

CFixedOutput * CComediInput::Output() const
{
	return (CFixedOutput*) *(FixedComponents().Begin());
}