/***************************************************************************
                          comediinput.h  -  description
                             -------------------
    begin                : Tue Mar 6 2001
    copyright            : (C) 2001 by Ivan Martinez
    email                : ivanmr@altavista.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef COMEDIINPUT_H
#define COMEDIINPUT_H

#include <comedichannel.h>

/**
  *@author Ivan Martinez
  */

#include <fixedoutput.h>

class CComediInput : public CComediChannel  {
public:
	/** Constructor */
	CComediInput();
	
	/** Destructor */
	~CComediInput();

	/** Returns "CComediInput" */
	virtual string Class() const;

	/** Returns TRUE if the argument is "CComediInput" or one of its
		base classes, otherwise FALSE */
	virtual bool DescendantOf(const string & ClassName) const;

	/** Returns the block's output */
	CFixedOutput* Output() const;
protected: // Protected methods
	/** Generates the function that executes the block */
	virtual void GenerateFunctions(ostream&, void*) const;
};

#endif
