/***************************************************************************
                          comedioutput.cpp  -  description
                             -------------------
    begin                : Tue Mar 6 2001
    copyright            : (C) 2001 by Ivan Martinez
    email                : ivanmr@altavista.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <comedioutput.h>

CComediOutput::CComediOutput()
{
	CFixedInput* Input;
	
	Input = new CFixedInput(this);
	Input->SetName("input");
	AddFixedComponent(Input);
}

CComediOutput::~CComediOutput()
{
}

string CComediOutput::Class() const
{
	return "CComediOutput";
}

bool CComediOutput::DescendantOf(const string & ClassName) const
{
	if (ClassName == "CComediOutput")
		return true;
	else
		return CComediChannel::DescendantOf(ClassName);
}

void CComediOutput::GenerateFunctions(ostream& Stream,
	void* pExtraParameter) const
{
	CStringsSet StringsSet;

	Stream << "void " << Identifier() << "(void)" <<	endl;
	Stream << "{" << endl;
	Stream << "  static lsampl_t data;" << endl;

	Stream << "  data = (lsampl_t) ((" << Input()->GlobalIdentifier() <<
		" - " << Offset() << ") / " << Range() << " * " << MaximumData() <<
		");" << endl;
	Stream << "  comedi_data_write(" << ComediMinor() << ", " <<
		ComediSubdevice() << ", " << ComediChannel() << ", " << ComediRange() <<
		", " << ComediReference() << ", data);" << endl;

	Stream << "}" << endl;
}

CFixedInput * CComediOutput::Input() const
{
	return (CFixedInput*) *(FixedComponents().Begin());
}

