/***************************************************************************
                          comedioutput.h  -  description
                             -------------------
    begin                : Tue Mar 6 2001
    copyright            : (C) 2001 by Ivan Martinez
    email                : ivanmr@altavista.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef COMEDIOUTPUT_H
#define COMEDIOUTPUT_H

#include <comedichannel.h>

/**
  *@author Ivan Martinez
  */

#include <fixedinput.h>

class CComediOutput : public CComediChannel  {
public:
	/** Constructor */
	CComediOutput();
	
	/** Destructor */
	~CComediOutput();

	/** Returns "CComediOutput" */
	virtual string Class() const;

	/** Returns TRUE if the argument is "CComediOutput" or one of its
		base classes, otherwise FALSE */
	virtual bool DescendantOf(const string &) const;

	/** Returns the block's input */
	CFixedInput* Input() const;
protected: // Protected methods
	/** Generates the function that executes the block */
	virtual void GenerateFunctions(ostream&, void*) const;
};

#endif
