/***************************************************************************
                          fixedinput.h  -  description
                             -------------------
    begin                : Fri Mar 2 2001
    copyright            : (C) 2001 by Ivan Martinez
    email                : ivanmr@altavista.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FIXEDINPUT_H
#define FIXEDINPUT_H

#include <input.h>

/**
  *@author Ivan Martinez
  */

#include <fixedoperationblock.h>

class CFixedInput : public CInput  {
public:
	/** Constructor. Requires the container of this component as the
		argument */
	CFixedInput(CFixedOperationBlock*);

	/** Destructor */	
	~CFixedInput();
	
	/** Generates the error 103 and returns FALSE, since fixed inputs can't
		be added to other components by the user */
	virtual bool AcceptsContainer(const CCodeGenerator*);
	
	/** Returns "CFixedInput" */
	virtual string Class() const;
	
	/** Returns the container of this component */
	const CFixedOperationBlock* Container() const;
	
	/** Returns TRUE if the argument is "CFixedInput" or one of its
		base classes, otherwise FALSE */
	virtual bool DescendantOf(const string&) const;

	/** Returns the type of the variable, which is the type returned by
		IOsType() in the container */
	virtual const string& Type() const;
};

#endif
