/***************************************************************************
                          fixedoperationblock.h  -  description
                             -------------------
    begin                : Thu Mar 1 2001
    copyright            : (C) 2001 by Ivan Martinez
    email                : ivanmr@altavista.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FIXEDOPERATIONBLOCK_H
#define FIXEDOPERATIONBLOCK_H

#include <block.h>

/**
  *@author Ivan Martinez
  */

class CFixedOperationBlock : public CBlock  {
public:
	/** Constructor */
	CFixedOperationBlock();
	
	/** Destructor */
	~CFixedOperationBlock();

	/** Returns TRUE if the argument is "CFixedOperationBlock" or one of its
		base classes, otherwise FALSE */
	virtual bool DescendantOf(const string&) const;

	/** Returns the type of the input and output variables */
	const string& IOsType() const;

	/** Sets the type of the input and output variables */
	bool SetIOsType(const string& Type);
private: // Private attributes
	/** Type of the input and output variables */
	string m_IOsType;
};

#endif
