/***************************************************************************
                          function.cpp  -  description
                             -------------------
    begin                : Tue Feb 15 2000
    copyright            : (C) 2000 by 
    email                : ivanmr@altavista.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <function.h>

#include <loop.h>
#include <dynamicsystem.h>

CFunction::CFunction()
{
	m_Code = "";
}

CFunction::~CFunction()
{
}

string CFunction::Class() const
{
	return "CFunction";
}

bool CFunction::DescendantOf(const string& ClassNameL) const
{
	if (ClassNameL == "CFunction")
		return true;
	else
		return CBlock::DescendantOf(ClassNameL);
}

bool CFunction::SetCode(const string& Code)
{
	m_Code = Code;

	return true;
}

const string& CFunction::Code() const
{
	return m_Code;
}

bool CFunction::LoopVariablesAccess() const
{
	return true;
}

bool CFunction::SystemVariablesAccess() const
{
	return true;
}

bool CFunction::LocalIOVariablesAccess() const
{
	return true;
}

void CFunction::GenerateFunctions(ostream& Stream,
	void* pExtraParameter = NULL) const
{
	CStringsSet StringsSet;

	Stream << "void " << Identifier() << "(void)" <<	endl;
	Stream << "{" << endl;

	StringsSet.clear();
	Container()->Container()->ComponentsGenerateCode(StringsSet, this,
		"flags declaration", pExtraParameter);
	copy(StringsSet.begin(), StringsSet.end(),
		ostream_iterator<string>(Stream, "\n"));
	Container()->Container()->ComponentsGenerateCode(Stream, this,
		"local system variable declarations", pExtraParameter);
	Container()->ComponentsGenerateCode(Stream, this,
		"local loop variable declarations", pExtraParameter);
	ComponentsGenerateCode(Stream, "local IO variables declaration",
		pExtraParameter);
	ComponentsGenerateCode(Stream, "block variables declaration",
		pExtraParameter);

	Container()->Container()->ComponentsGenerateCode(Stream, this,
		"system variables reading", pExtraParameter);
	Container()->ComponentsGenerateCode(Stream, this,
		"loop variables reading", pExtraParameter);
	ComponentsGenerateCode(Stream, "inputs reading", pExtraParameter);
	ComponentsGenerateCode(Stream, "block variables reading",
		pExtraParameter);

	Stream << Code() << endl;

	ComponentsGenerateCode(Stream, "block variables writing",
		pExtraParameter);
	ComponentsGenerateCode(Stream, "outputs writing", pExtraParameter);
	Container()->ComponentsGenerateCode(Stream, this,
		"loop variables writing", pExtraParameter);
	Container()->Container()->ComponentsGenerateCode(Stream, this,
		"system variables writing", pExtraParameter);

	Stream << "}" << endl;
}
