/***************************************************************************
                          functionvariable.h  -  description
                             -------------------
    begin                : Mon Jul 10 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivanmr@altavista.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FUNCTIONVARIABLE_H
#define FUNCTIONVARIABLE_H

#include <variable.h>

/**
  *@author Ivan Martinez
  */

#include <function.h>

class CFunctionVariable : public CVariable  {
public:
	/** Constructor */
	CFunctionVariable();

	/** Destructor */
	~CFunctionVariable();

	/** If the paramater is DescendantOf("CFunction"),
		sets it as the container of this component and returns true.
		If it isn't, generates the error 101 and retuns false */
	virtual bool AcceptsContainer(const CCodeGenerator*);

	/** Returns "CFunctionVariable" */
	virtual string Class() const;

	/** Returns the container of this component */
	const CFunction* Container() const;

	/** Returns TRUE if the argument is "CFunctionVariable" or one of its base
		classes, otherwise FALSE */
	virtual bool DescendantOf(const string&) const;

	/** Calls a code generation function depending on the arguments */
	virtual void GenerateCode(ostream&, const CCodeGenerator*, const string&,
		void* = NULL) const;

	/** Returns the name of this component */
	const string& Name() const;

	/** Sets the name of this component */
	bool SetName(const string&);

	/** Sets the type of the variable */
	bool SetType(const string&);
};

#endif
