/***************************************************************************
                          initializablevariable.cpp  -  description
                             -------------------
    begin                : Mon Jun 5 2000
    copyright            : (C) 2000 by Ivan Martinez
    email                : ivanmr@altavista.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <initializablevariable.h>

CInitializableVariable::CInitializableVariable()
{
	m_Initialization = "";
}

CInitializableVariable::~CInitializableVariable()
{
}

const string& CInitializableVariable::Initialization() const
{
	return m_Initialization;
}

void CInitializableVariable::SetInitialization(const string& Initialization)
{
	m_Initialization = Initialization;
}

void CInitializableVariable::GenerateInitialization(ostream& StreamL,
	void* ExtraParameterL = NULL) const
{
	if (!Initialization().empty())
		StreamL << Initialization() << endl;
}

void CInitializableVariable::GenerateInitializationDeclaration(
	ostream& StreamL,	void* ExtraParameterL = NULL) const
{
	if (Initialized())	
		StreamL	<< "  " << Type() << " " << Identifier() << ";" << endl;
}

void CInitializableVariable::GenerateInitializationWriting(ostream& StreamL,
	void* ExtraParameterL = NULL) const
{
	if (Initialized())	
		StreamL << "  " << GlobalIdentifier() << " = " << Identifier() <<
		";" << endl;
}

bool CInitializableVariable::Initialized() const
{
  return (!Initialization().empty());
}

bool CInitializableVariable::DescendantOf(const string& ClassName) const
{
	if (ClassName == "CInitializableVariable")
		return true;
	else
		return CDualVariable::DescendantOf(ClassName);
}
