/***************************************************************************
                          summinginput.h  -  description
                             -------------------
    begin                : Wed Mar 14 2001
    copyright            : (C) 2001 by Ivan Martinez
    email                : ivanmr@altavista.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SUMMINGINPUT_H
#define SUMMINGINPUT_H

#include <fixedinput.h>

/**
  *@author Ivan Martinez
  */

class CSummingPoint;

class CSummingInput : public CFixedInput  {
public:
	/** Constructor. Requires the container of this component as the
		argument */
	CSummingInput(CSummingPoint*);
	
	/** Destructor */
	~CSummingInput();

	/** Returns "CSummingInput" */
	virtual string Class() const;

	/** Returns TRUE if the argument is "CSummingInput" or one of its
		base classes, otherwise FALSE */
	virtual bool DescendantOf(const string&) const;

	/** Returns if the input is substracted in the summing point */
	bool Negated() const;

	/** Sets if the input is substracted in the summing point */
	bool SetNegated(bool);
private: // Private attributes
  /** If TRUE the input is substracted in the summing point, if FALSE it
  	is added */
  bool m_fNegated;
};

#endif
