/***************************************************************************
                          summingpoint.h  -  description
                             -------------------
    begin                : Tue Mar 13 2001
    copyright            : (C) 2001 by Ivan Martinez
    email                : ivanmr@altavista.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SUMMINGPOINT_H
#define SUMMINGPOINT_H

#include <fixedoperationblock.h>

/**
  *@author Ivan Martinez
  */

#include <summinginput.h>
#include <fixedoutput.h>

class CSummingPoint : public CFixedOperationBlock  {
public:
	/** Constructor */
	CSummingPoint();
	
	/** Destructor */
	~CSummingPoint();

	/** Returns "CSummingPoint" */
	virtual string Class() const;
	
	/** Returns TRUE if the argument is "CSummingPoint" or one of its
		base classes, otherwise FALSE */
	virtual bool DescendantOf(const string&) const;

	/** Returns the input corresponding to the index indicated as parameter,
		from 1 to NumberOfInputs() */
	CSummingInput* Input(unsigned int);
	
	/** Returns the number of inputs */
	unsigned int NumberOfInputs() const;
	
	/** Returns the output */
	CFixedOutput* Output() const;
	
	/** Sets the number of inputs */
	bool SetNumberOfInputs(unsigned int);
protected: // Protected methods
  /** Generates the function that executes the block */
  virtual void GenerateFunctions(ostream&, void*) const;
};

#endif
