/***************************************************************************
                          variablesharedmemory.cpp  -  description
                             -------------------
    begin                : Fri Feb 16 2001
    copyright            : (C) 2001 by Ivan Martinez
    email                : ivanmr@altavista.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <variablesharedmemory.h>
#include <strstream>

CVariableSharedMemory::CVariableSharedMemory()
{
}

CVariableSharedMemory::~CVariableSharedMemory()
{
}

void CVariableSharedMemory::GenerateCode(CStringsSet& StringsSet,
	const CCodeGenerator* pCaller, const string& Section,
	void* pExtraParameter= NULL) const
{
	if (pCaller->DescendantOf("CLoop"))
		if (Section == "local variables declaration")
			GenerateLoopDeclarations(StringsSet, pExtraParameter);
}

void CVariableSharedMemory::GenerateInitialization(ostream& Stream,
	void* pExtraParameter = NULL) const
{
	Stream << "  " << Identifier() << " = (" << DataType() << "*) __va(" <<
		DataOffset() << ");" << endl;
	Stream << "  " << LockIdentifier() << " = (" << LockType() << "*) __va(" <<
		DataOffset() << " + sizeof(" << DataType() << "));" << endl;
}

void CVariableSharedMemory::GenerateLockAcquisition(ostream& Stream,
	void* pExtraParameter = NULL) const
{
	Stream << "      if ((char) *" << LockIdentifier() << ")" << endl;
	Stream << "      {" << endl;
}

void CVariableSharedMemory::GenerateLockRelease(ostream& Stream,
	void* pExtraParameter = NULL) const
{
	Stream << "        *" << LockIdentifier() << " = 0;" << endl;
	Stream << "      }" << endl;
}

void CVariableSharedMemory::GenerateLoopDeclarations(CStringsSet& StringsSet,
	void* pExtraParameter = NULL) const
{
	if (Container()->DescendantOf("CSystemVariable"))
		StringsSet.insert("  static unsigned long flags;");
}

off_t CVariableSharedMemory::Offset() const
{
	strstream Stream;
	off_t Offset;

	Stream << CProtectedSharedMemory::DataOffset();
	Stream >> Offset;
	return Offset;
}

bool CVariableSharedMemory::SetOffset(off_t Offset)
{
  strstream Stream;

  Stream << Offset << ends;
	CProtectedSharedMemory::SetDataOffset(Stream.str());
	
	return true;
}