/*
 *  linux_ipc.h -- IPC primitives for communication with Real-Time Linux tasks
 *
 *  Copyright (C) 1997 Jerry Epplin.  All rights reserved.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  History:
 *   15-Aug-97 jhe  V0.1 Original.
 */

#define IPC_RTF_NO		64	/* should be same as in rt_fifo_new.c */

#define RT_WAIT_FOREVER	-1	/* use for no timeout on funcs with timeout */
#define RT_NO_WAIT	0	/* use for return immediately if can't */
  				/* perform operation */

extern int rtf_ipc_create(unsigned int fifo, int size, int rtl_to_linux);
extern int rtf_ipc_destroy(unsigned int fifo);
extern int rtf_receive(unsigned int fifo, void *buf, int count, RTIME timeout);
extern int rtf_send(unsigned int fifo, void *buf, int count, RTIME timeout);
