#include <stdio.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <linux/fs.h>
#include <asm/rt_time.h>
#include "../linux_ipc.h"

#define RT_TO_LINUX	1
#define LINUX_TO_RT	2

static const char data[] = "I know it is wet and the sun is not sunny.       \n"
                           "But we can have lots of good fun that is funny.  \n";

/* Simply sends a string repeatedly, and waits for it to be echoed back */
/* by the real-time task. */
int main()
{
  char buf[201];
  int i, ret;
  if ((ret = rtf_ipc_create(RT_TO_LINUX, 200, 1)) < 0)
  {
    printf("linux_test: rtf_ipc_create() failed with %d\n", ret);
    exit(1);
  }
  if ((ret = rtf_ipc_create(LINUX_TO_RT, 200, 0)) < 0)
  {
    printf("linux_test: rtf_ipc_create() failed with %d\n", ret);
    exit(1);
  }
  for (i=0 ; i<5 ; ++i)
  {
    ret = rtf_send(LINUX_TO_RT, (char *)data, strlen(data), RT_WAIT_FOREVER);
    if (ret < 0)
      printf("linux_test: rtf_send() failed with %d\n", ret);
    ret = rtf_receive(RT_TO_LINUX, buf, strlen(data), RT_WAIT_FOREVER);
    if (ret < 0)
      printf("linux_test: rtf_receive() failed with %d\n", ret);
    buf[strlen(buf)] = '\0';
    printf("%s", buf);
  }
  return 0;
}
