/*Copyright (C) 1999 by Heinz Haeberle, heinz.haeberle@gmx.net

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.*/

#ifndef __RTLIODRV_H__
#define __RTLIODRV_H__

typedef char tDIOBool;

typedef struct{
	tDIOBool value;
} sGlobalDigital;

#define MAXDICHANNEL	100
#define MAXDOCHANNEL	100
#define MAXMERKER 		100

#define IOMBUFFSIZE (sizeof(IODataDI[0]) * MAXDICHANNEL) + \
				(sizeof(IODataDO[0]) * MAXDOCHANNEL) + \
				(sizeof(IODataM[0]) * MAXMERKER)

typedef enum{
	IOCMD_GetDI,
	IOCMD_SyncDI,
	IOCMD_SetDO,
	IOCMD_SyncDO
} eIOCommand;

typedef union{
	sGlobalDigital *diptr;
	sGlobalDigital *doptr;
} uIOParam;

typedef int (*IOFunction)(eIOCommand, uIOParam);

int IOAddDIFunction(int channels, IOFunction fn);
int IOAddDOFunction(int channels, IOFunction fn);
int IORemDIFunction(IOFunction fn);
int IORemDOFunction(IOFunction fn);
int IOSyncDI(int fromchannel, int channels);
int IOSyncDO(int fromchannel, int channels);

extern sGlobalDigital *IODataDI;
extern sGlobalDigital *IODataDO;
extern sGlobalDigital *IODataM;

#define IODRV_SHM_NAME "RTLIODRV"
#endif //__RTLIODRV_H__