/*Copyright (C) 1999 by Heinz Haeberle, heinz.haeberle@gmx.net

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.*/

#include <stdio.h>
#include "iodrv.h"
#include "softplc.h"

int main(int argc, char *argv[])
{
	FILE *fp;	
	int i;
	if (argc < 2)
	{
		fprintf(stderr, "usage: %s <outputfilename>\n example: %s iodefine.h\n",argv[0], argv[0]);
		return -1;
	}
	fp = fopen(argv[1], "wt");
	if (!fp)
	{
		fprintf(stderr,"can't create %s\n", argv[1]);
		return -1;
	}
	fprintf(fp, "/* this is a generated file, please don't edit! */\n\n"
				"#ifndef IODEFINE_EXECUTE\n");
	for (i=0;i<MAXDICHANNEL;i++)
		fprintf(fp,"#define E%i_%i IODataDI[%i].value\n", i/8,i%8,i);
	for (i=0;i<MAXDOCHANNEL;i++)
		fprintf(fp,"#define A%i_%i IODataDO[%i].value\n", i/8,i%8,i);
	for (i=0;i<MAXMERKER;i++)
		fprintf(fp,"#define M%i_%i IODataM[%i].value\n", i/8,i%8,i);
	for (i=0;i<MAXTIMER;i++)
		fprintf(fp,"#define T%i &PLCTimer[%i]\n", i,i);
	for (i=0;i<MAXCOUNTER;i++)
		fprintf(fp,"#define Z%i &PLCCounter[%i]\n", i,i);
	fprintf(fp, "\n#else\n\n");
	for (i=0;i<MAXDICHANNEL/8;i++)
		fprintf(fp,"PLCByte EB%i;\n",i);
	for (i=0;i<MAXDOCHANNEL/8;i++)
		fprintf(fp,"PLCByte AB%i;\n",i);
	for (i=0;i<MAXMERKER/8;i++)
		fprintf(fp,"PLCByte MB%i;\n",i);
	fprintf(fp,	"void InitPLC1(void){\n"
				"	memset(PLCTimer,0, sizeof(PLCTimer));\n"
				"	memset(PLCCounter,0, sizeof(PLCCounter));\n");
	for (i=0;i<MAXDICHANNEL/8;i++)
		fprintf(fp,"    EB%i.setdata(&IODataDI[%i]);\n", i, i*8);
	for (i=0;i<MAXDOCHANNEL/8;i++)
		fprintf(fp,"    AB%i.setdata(&IODataDO[%i]);\n", i, i*8);
	for (i=0;i<MAXMERKER/8;i++)
		fprintf(fp,"    MB%i.setdata(&IODataM[%i]);\n", i, i*8);
	fprintf(fp, "}\n#endif\n");
	fclose(fp);
	return 0;
}
