#include <stdio.h>
#include <stdlib.h>
#ifdef __DOS__
#include <mem.h>
#include <dos.h>
#include <conio.h>
#else
#include <time.h>
#include <curses.h>
#include <unistd.h>
#include <rtlinux/mbuff.h>
//#include <sys/mman.h>
#include "iodrv.h"
#endif
#include "softplc.h"
#include "plcfunc.h"
#include "plc.h"	// this the PLC-user-program


tPLCTime ActualPLCTime=0;

sGlobalDigital *IODataDI;
sGlobalDigital *IODataDO;
sGlobalDigital *IODataM;

#define CYCLETIME 100
#define CURSORMAXX 80
#define CURSORMAXY 20

typedef struct
{
	int x,y; // the x and y position of the cursor

} sCursor;
static sCursor Cursor={1,1};
typedef struct
{
	int xpos,xsize;
	int ypos,ysize;
} sValueWindow;

static sValueWindow EingangValueWindow={2,72,2,1};
static sValueWindow MerkerValueWindow={2,72,5,1};
static sValueWindow AusgangValueWindow={2,72,8,1};

#ifdef __DOS__
void initWindow()
{
}
void gotopos(int x, int y)
{
	gotoxy(x,y);
}
void printstr(char * ptr)
{
	printf(ptr);
}
void exitWindow()
{
}
#define KEY_LEFT	5000
#define KEY_RIGHT	5001
#define KEY_UP		5002
#define KEY_DOWN    5003
int getkey()
{
	int ch;
	if(kbhit())
		return 0;
	ch = getch()
	switch(ch)
	{
		case 0:	// es folgt noch der scancode
			ch = getch();
			switch(ch)
			{
				case 75: //links
					return KEY_LEFT;
				case 77: //rechts
					return KEY_RIGHT;
				case 72: //oben
					return KEY_UP;
				case 80: //unten
					return KEY_DOWN;
			}
		  break;
	}
	return ch;
}
void refreshscr()
{
}
void udelay(int ms)
{
	delay(ms);
}
#else
static int useRTLPLC = 0;	// if true the mbuff interface to the I/O's are used
WINDOW *win;
void initWindow()
{
	initscr();
	savetty();
	win = newwin(0,0,0,0);
	wattrset(win,COLOR_PAIR(1));
	keypad(win, 1);
	nodelay(win, 1);
}
void exitWindow()
{
	resetty();
	delwin(win);
	endwin();
}
void gotopos(int x, int y)
{
	wmove(win,y-1,x-1);
}
void printstr(char * ptr)
{
	waddstr(win,ptr);
}

int getkey()
{
	return wgetch(win);
}
void refreshscr()
{
	wrefresh(win);
}
void udelay(int ms)
{
	usleep(ms*1000);
}
#endif

int Display(int all)	// if all ist != 0 -> the frames are display too
{
	int i,j;
	sValueWindow *win;
	char buf[100];
	char *ptr;
	char Buffer[100];
	for (i=0;i<3;i++)
	{
		switch(i)
		{
			case 0:
				win = &EingangValueWindow;
				ptr = "*** Input ***";
			  break;
			case 1:
				win = &MerkerValueWindow;
				ptr = "** Memory ***";
			  break;
			case 2:
				win = &AusgangValueWindow;
				ptr = "** Output ***";
			  break;
		}
		// now we can start to print the frames and values
		if (all)
		{
			gotopos(win->xpos-1,win->ypos-1);
			memset(buf,0	,sizeof(buf));
			memset(buf,'*',(win->xsize/2) - 7/*=half of ptr*/ +2);
			sprintf(Buffer, "%s%s%s\n*",buf,ptr,buf);
			printstr(Buffer);
		}
		gotopos(win->xpos,win->ypos);
		for (j=0;j<((win->xsize)/9)*8;j++)
		{
			if((j%8) == 0)
				printstr(" ");
			switch(i)
			{
				case 0:
					printstr(IODataDI[j].value == 0 ? "0" : "1");
				  break;
				case 1:
					printstr(IODataM[j].value == 0 ? "0" : "1");
				  break;
				case 2:
					printstr(IODataDO[j].value == 0 ? "0" : "1");
				  break;
			}
		}
		if (all)
		{
			printstr(" *");	// hinten kommt auch was hin!
			gotopos(win->xpos-1,win->ypos+1);
			memset(buf,0,sizeof(buf));
			memset(buf,'*',win->xsize+3);
			printstr(buf);
			printstr("\n");
		}
	}
	if (all)
	{
		printstr( "ESC = exit  1/0/space = set/reset/toggle Value on Cursorposition\n");
	}
	return 0;
}

void ChangeValue(int x , int y, int value)
{
	int i,j;
	sValueWindow *win;
	// lets find out what value we want to change, and if
	// there is any on this position
	for (i=0;i<3;i++)
	{
		switch(i)
		{
			case 0:
				win = &EingangValueWindow;
			  break;
			case 1:
				win = &MerkerValueWindow;
			  break;
			case 2:
				win = &AusgangValueWindow;
			  break;
		}
		if((y < win->ypos) || (y >= (win->ypos + win->ysize)))
			continue;
		if((x < win->xpos) || (x >= (win->xpos + win->xsize)))
			continue;
		// now check about the gaps between
		if (((x - win->xpos +1 )%9) == 8)
			continue;
		// we have a position with a value
		j = 8* ((x - win->xpos)/9) + ((x - win->xpos-1)%9);
		switch(i)
		{
			case 0:
				if (value == -1)
					IODataDI[j].value = (IODataDI[j].value==0) ? 1 : 0;
				else
					IODataDI[j].value = value;
			  break;
			case 1:
				if (value == -1)
					IODataM[j].value = (IODataM[j].value==0) ? 1 : 0;
				else
					IODataM[j].value = value;
			  break;
			case 2:
				if (value == -1)
					IODataDO[j].value = (IODataDO[j].value==0) ? 1 : 0;
				else
					IODataDO[j].value = value;
			  break;
		}
		break;	// this breaks the for-loop!
	}
}

void spstask(void)
{
	int ch;
	InitPLC();
	Display(1);
	if (!useRTLPLC)
		OB21();
	while(1)
	{	
		ch = getkey();
		switch(ch)
		{
			case 27:
			case 'q':
				return;
			  break;
			case KEY_LEFT: //links
				if (Cursor.x > 1)
					Cursor.x--;
			  break;
			case KEY_RIGHT: //rechts
				if (Cursor.x < CURSORMAXX)
					Cursor.x++;
			  break;
			case KEY_UP: //oben
				if (Cursor.y > 1)
					Cursor.y--;
			  break;
			case KEY_DOWN: //unten
				if (Cursor.y < CURSORMAXY)
					Cursor.y++;
			  break;
			case '1':
			case '0':	// we want to set the value to 0 or 1
				ChangeValue(Cursor.x,Cursor.y,ch-'0');
			  break;
			case ' ':	// we want to set the value to 0 or 1
				ChangeValue(Cursor.x,Cursor.y,-1);
			  break;
		}
		Display(0);
		gotopos(Cursor.x,Cursor.y);
		if (!useRTLPLC)
			OB1();
		refreshscr();
		udelay(CYCLETIME);
		ActualPLCTime+=CYCLETIME;
	}
}

int main(int argc, char *argv[])
{
#ifndef __DOS__
	// process the commandline to find out if we should use the
	// shared memory to communicate to the realtime plc or
	// if we should use the emulation without the rtl-plc
	if (argc > 1)
		if (strcmp(argv[1], "rtl") == 0)
			useRTLPLC = 1;
	if (useRTLPLC)
	{
		IODataDI = (sGlobalDigital*)mbuff_attach(IODRV_SHM_NAME,IOMBUFFSIZE);
		if (!IODataDI)
		{
			printf("can't allocate shared mem!\n");
			return -1;
		}
		IODataDO = &IODataDI[MAXDICHANNEL];
		IODataM  = &IODataDO[MAXDOCHANNEL];
	}
	else
#endif	
	{
		IODataDI = (sGlobalDigital*)malloc(IOMBUFFSIZE);
		if (!IODataDI)
		{
			printf("can't allocate mem!\n");
			return -1;
		}
		IODataDO = &IODataDI[MAXDICHANNEL];
		IODataM  = &IODataDO[MAXDOCHANNEL];
		memset(IODataDI, 0, IOMBUFFSIZE);
	}
	initWindow();
	spstask();
	exitWindow();
#ifndef __DOS__
	if (useRTLPLC)
		mbuff_detach(IODRV_SHM_NAME, IODataDI);
#endif		
	return 0;
}
