/*Copyright (C) 1999 by Heinz Haeberle, heinz.haeberle@gmx.net

This s a rtl module for the parallelport

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.*/

#include <linux/module.h>
#include <linux/kernel.h>
#include <asm/io.h>
#include <rtl.h>
#include <rtl_fifo.h>
#include <time.h>
#include <rtl_sched.h>
#include <rtl_sync.h>
#include <rtl_time.h>
#include "iodrv.h"

static int iocallbackfn(eIOCommand cmd, uIOParam para)
{
	int ret = -2;
#if 1
	switch(cmd)
	{
		case IOCMD_SyncDI:
		{
			ret = 0;
		}  break;
		case IOCMD_SyncDO:
		{
			unsigned char value	= 
				((para.diptr[0].value != 0) ? 1   : 0) +
				((para.diptr[1].value != 0) ? 2   : 0) +
				((para.diptr[2].value != 0) ? 4   : 0) +
				((para.diptr[3].value != 0) ? 8   : 0) +
				((para.diptr[4].value != 0) ? 16  : 0) +
				((para.diptr[5].value != 0) ? 32  : 0) +
				((para.diptr[6].value != 0) ? 64  : 0) +
				((para.diptr[7].value != 0) ? 128 : 0);
			outb(value, 0x378);
		}  break;
		case IOCMD_GetDI:
		case IOCMD_SetDO:
			return -1;
	}
#endif	
	return ret;
}

int init_module(void)
{
//	IOAddDIFunction(4,iocallbackfn);
	IOAddDOFunction(8,iocallbackfn);
	return 0;
}

void cleanup_module(void)
{
//	IORemDIFunction(iocallbackfn);
	IORemDOFunction(iocallbackfn);
}
