/*Copyright (C) 1999 by Heinz Haeberle, heinz.haeberle@gmx.net

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.*/

#include <linux/module.h>
#include <linux/kernel.h>
#include <asm/io.h>
#include <rtl.h>
#include <rtl_fifo.h>
#include <time.h>
#include <rtl_sched.h>
#include <rtl_sync.h>
#include <rtl_time.h>
#include <string.h>
//#include "iodrv.h"
#include "softplc.h"
#include "plcfunc.h"
#include "plc.h"
#include <rtl_debug.h>

#define PERIOD 10LL

tPLCTime ActualPLCTime=0;

void TimeSync(void)
{
	hrtime_t t_now;
	t_now = gethrtime();
// because this doesn't work we have to make a workaround
	t_now = t_now / 1000000LL;
//	t_now = t_now >> 20;
	ActualPLCTime = (tPLCTime)t_now;
}

pthread_t thread;

static void *plctask(void *dummy)
{
	pthread_make_periodic_np(pthread_self(),gethrtime(),1000LL*1024LL*PERIOD);
	TimeSync();
	InitPLC();
	OB21();
	while(1)
	{
		IOSyncDI(0,-1);
		TimeSync();
		OB1();
		IOSyncDO(0,-1);
		pthread_wait_np();           
	}		
	return NULL;
}

int init_module(void)
{
	pthread_attr_t attr;
	struct sched_param sched_param;
	int thread_status;
	pthread_attr_init (&attr);
	sched_param.sched_priority = 1;
	pthread_attr_setschedparam (&attr, &sched_param);
	thread_status = pthread_create (&thread,  &attr, plctask, (void *)1);
	if (thread_status != 0) {
		rtl_printf("failed to create RT-thread; errno=\n", errno);
		return -1;
	} else {
 		rtl_printf("created RT-thread\n"); 
	}
	return 0;
}


void cleanup_module(void)
{
	pthread_delete_np (thread);
}
