#include <Xm/Xm.h>
#include <Xm/FileSB.h>
#include <Xm/MessageB.h>
#include <X11/cursorfont.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <fstream.h>
#include <errno.h>
#include "global.h"

void f_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget        toplevel;
  int           item, n;
  Arg           args[5];
  static Widget fsb_ls, fsb_ss, fsb_sd, needsave;

  void ls_cb(Widget, XtPointer, XtPointer);
  void ss_cb(Widget, XtPointer, XtPointer);
  void sd_cb(Widget, XtPointer, XtPointer);
  void quit_cb(Widget, XtPointer, XtPointer);
  void fsb_cancel(Widget, XtPointer, XtPointer);
  
  toplevel=XtParent(widget);
  while (!XtIsTopLevelShell(toplevel)) toplevel=XtParent(toplevel);

  item=(int) client_data;
  switch(item) {
  case 0:      // load setup;
    if (!fsb_ls) {
      fsb_ls=XmCreateFileSelectionDialog(toplevel, "filesb", NULL, 0);
      XtAddCallback(fsb_ls,XmNokCallback, ls_cb, NULL);
      XtAddCallback(fsb_ls,XmNcancelCallback, fsb_cancel, NULL);
      XtVaSetValues(XtParent(fsb_ls),
		    XmNtitle, "Load Setup",
		    NULL);
    }
    XtManageChild(fsb_ls);
    break;
  case 1:      // save setup;
    if (!fsb_ss) {
      fsb_ss=XmCreateFileSelectionDialog(toplevel, "filesb", NULL, 0);
      XtAddCallback(fsb_ss,XmNokCallback, ss_cb, NULL);
      XtAddCallback(fsb_ss,XmNcancelCallback, fsb_cancel, NULL);
      XtVaSetValues(XtParent(fsb_ss),
		    XmNtitle, "Save Setup",
		    NULL);
    }
    XtManageChild(fsb_ss);
    break;
  case 2:      // save data;
    if (!fsb_sd) {
      fsb_sd=XmCreateFileSelectionDialog(toplevel, "filesb", NULL, 0);
      XtAddCallback(fsb_sd,XmNokCallback, sd_cb, NULL);
      XtAddCallback(fsb_sd,XmNcancelCallback, fsb_cancel, NULL);
      XtVaSetValues(XtParent(fsb_sd),
		    XmNtitle, "Save Data",
		    NULL);
    }
    XtManageChild(fsb_sd);
    break;
  case 3:      // quit;
    if (!reg.recon) {
      if (XtIsSensitive(mymenu.file.s_data)) {
	if (!needsave) {
	  n=0;
	  XtSetArg(args[n], XmNmessageString, XmStringCreateLtoR("      Data not saved!\nDo you really want to quit?", XmFONTLIST_DEFAULT_TAG)); n++;
	  XtSetArg(args[n], XmNokLabelString, XmStringCreateLocalized(" Yes ")); n++;
	  XtSetArg(args[n], XmNcancelLabelString, XmStringCreateLocalized(" No ")); n++;
	  XtSetArg(args[n], XmNtitle, "Really Quit ?"); n++;
	  needsave=XmCreateQuestionDialog(toplevel, "savedata", args, n);
	  XtAddCallback(needsave, XmNokCallback, quit_cb, NULL);
	  XtUnmanageChild(XmMessageBoxGetChild(needsave, XmDIALOG_HELP_BUTTON));
	}
	XtManageChild(needsave);
	XtPopup(XtParent(needsave), XtGrabNone);
      }
      else {
	exit(0);
      }
    }
    break;
  }
}

/* ..................................*/
/* .....   C a l l b a c k s   ..... */
/* ................................. */

void ls_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  int           i, j, k;
  float         ver;
  char          *filename, c, s[20];
  Cursor        uhr, pfeil;
  ifstream      dat;
  
  extern void clearscreen(Window window);

  XmFileSelectionBoxCallbackStruct *cbs=
    (XmFileSelectionBoxCallbackStruct *) call_data;

  if (!XmStringGetLtoR(cbs->value, XmFONTLIST_DEFAULT_TAG, &filename)) {
    cout << "Internal error pasting filename! \n";
    return;
  }
  if (!*filename) {
    cout << "No file selected! \n";
    XtFree(filename);
    return;
  }

  uhr  =XCreateFontCursor(XtDisplay(widget),XC_watch);
  pfeil=XCreateFontCursor(XtDisplay(widget), XC_arrow);

  XDefineCursor(XtDisplay(widget),XtWindow(widget),uhr);
  XFlush(XtDisplay(widget));

  /* E i n g a b e d a t e i   l e s e n   */
  dat.open(filename);
  if (!dat) {
    cout << "Cannot open file \n";
    return;
  }
  /* zuerst allgemeine Daten */
  dat >> ver;
  if (ver>0) {
    reg.sr=(int)ver;
    ver=1.5;
  }
  else ver*=(-1);
  if (ver>1.5) dat >> reg.sr;
  dat >> reg.length;
  /* danach Daten fr alle 8 Kanle */
  reg.nactive=0; der.nactive=0;
  for (i=0; i<8; i++) {
    dat >> j;
    dat >> ch[i].active;
    if (ch[i].active) {
      reg.nactive++;
      XtSetSensitive(mymenu.calibrate.channel[i],True);
    }
    else XtSetSensitive(mymenu.calibrate.channel[i],False);
    if (ver>1.5) dat >> ch[i].polarity;
    dat >> ch[i].color;
    dat >> ch[i].height;
    dat >> j;
    dat >> ch[i].cal.ad_low;
    dat >> ch[i].cal.ad_high;
    dat >> ch[i].cal.rw_low;
    dat >> ch[i].cal.rw_high;
    if (ver>2.2) {
      dat >> j;
      dat >> dch[i].threshold;
      dat >> dch[i].movavg;
      dch[i].mavg=(int *)realloc(dch[i].mavg, dch[i].movavg*sizeof(int));
      dch[i].masum=0;
      dat >> dch[i].ampli;
      dch[i].nch=0;
      for (k=0; k<7; k++) {
	dat >> j; dat >> j;
	dat >> dch[i].ch[k].active;
	if (dch[i].ch[k].active) {
	  dch[i].nch++;
	  XtSetSensitive(mymenu.calibrate.channel[i],True);
	}
	dat >> dch[i].ch[k].color;
	dat >> dch[i].ch[k].height;
	dat >> j; dat >> j;
	dat >> dch[i].ch[k].cal.ad_low;
	dat >> dch[i].ch[k].cal.ad_high;
	dat >> dch[i].ch[k].cal.rw_low;
	dat >> dch[i].ch[k].cal.rw_high;
      }
      if (dch[i].nch>0) der.nactive++;
    }
  }
  reg.nbuf = reg.length*reg.sr/reg.xpix;
  if (reg.nbuf<1) {
    reg.nbuf=1;
    reg.length=reg.nbuf*reg.xpix/reg.sr;
  }
    sprintf(s,"%d", reg.length);
    XtVaSetValues(trace_label,
		  XtVaTypedArg, XmNlabelString, XmRString, s, strlen(s)+1,
		  NULL);
    sprintf(s,"%d", reg.sr);
    XtVaSetValues(sr_label,
		  XtVaTypedArg, XmNlabelString, XmRString, s, strlen(s)+1,
		  NULL);
  
  dat.close();
  XtFree(filename);
  XDefineCursor(XtDisplay(widget),XtWindow(widget),pfeil);
  XtUnmanageChild(widget);
  XFreeCursor(XtDisplay(widget), pfeil);
  XFreeCursor(XtDisplay(widget), uhr);
  if ((reg.nactive+der.nactive) > 0) XtSetSensitive(mymenu.recording.s_recording, True);
  clearscreen(XtWindow(drawing_a));
  return;
}

void ss_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  int           i, n;
  Arg           args[5];
  static Widget fexist;
  char          *filename;
  ofstream      dat;
  extern int    errno;
  void write_setup(char *, Widget);
  void over_setup(Widget, XtPointer, XtPointer);

  XmFileSelectionBoxCallbackStruct *cbs= 
    (XmFileSelectionBoxCallbackStruct *) call_data;
  if (!XmStringGetLtoR(cbs->value, XmFONTLIST_DEFAULT_TAG, &filename)) {
    cout << "Internal error pasting filename! \n";
    return;
  }
  if (!*filename) {
    cout << "No file selected! \n";
    XtFree(filename);
    return;
  }
  dat.open(filename, ios::noreplace);
  if (errno==EEXIST) {
    if (!fexist) {
      n=0;
      XtSetArg(args[n], XmNmessageString, XmStringCreateLtoR("File already exists.\n     Overwrite?",XmFONTLIST_DEFAULT_TAG)); n++;
      XtSetArg(args[n], XmNokLabelString, XmStringCreateLocalized(" Yes ")); n++;
      XtSetArg(args[n], XmNcancelLabelString, XmStringCreateLocalized(" No ")); n++;
      XtSetArg(args[n], XmNtitle, "Save Setup"); n++;
      fexist=XmCreateQuestionDialog(widget, "fexist", args, n);
      XtAddCallback(fexist, XmNokCallback, over_setup, widget);
      XtUnmanageChild(XmMessageBoxGetChild(fexist, XmDIALOG_HELP_BUTTON));
    }
    XtManageChild(fexist);
    XtPopup(XtParent(fexist), XtGrabNone);
  }
  if (dat) {
    dat.close();
    write_setup(filename, widget);
  }
  XtFree(filename);
  return;
}

void sd_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  char          *filename;
  ofstream      dat;
  int           n;
  Arg           args[5];
  static Widget fexist;
  extern int    errno;
  void          write_data(char *, Widget);
  void          over_data(Widget, XtPointer, XtPointer);

  XmFileSelectionBoxCallbackStruct *cbs=
    (XmFileSelectionBoxCallbackStruct *) call_data;
  if (!XmStringGetLtoR(cbs->value, XmFONTLIST_DEFAULT_TAG, &filename)) {
    cout << "Internal error pasting filename! \n";
    return;
  }
  if (!*filename) {
    cout << "No file selected! \n";
    XtFree(filename);
    return;
  }

  dat.open(filename, ios::noreplace);
  if (errno==EEXIST) {
    if (!fexist) {
      n=0;
      XtSetArg(args[n], XmNmessageString, XmStringCreateLtoR("File already exists.\n     Overwrite?",XmFONTLIST_DEFAULT_TAG)); n++;
      XtSetArg(args[n], XmNokLabelString, XmStringCreateLocalized(" Yes ")); n++;
      XtSetArg(args[n], XmNcancelLabelString, XmStringCreateLocalized(" No ")); n++;
      XtSetArg(args[n], XmNtitle, "Save Data"); n++;
      fexist=XmCreateQuestionDialog(widget, "fexist", args, n);
      XtAddCallback(fexist, XmNokCallback, over_data, widget);
      XtUnmanageChild(XmMessageBoxGetChild(fexist, XmDIALOG_HELP_BUTTON));
    }
    XtManageChild(fexist);
    XtPopup(XtParent(fexist), XtGrabNone);
  }
  if (dat) {
    dat.close();
    write_data(filename, widget);
  }

  XtFree(filename);
  return;
}

void quit_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  exit(0);
}

void fsb_cancel(Widget widget, XtPointer client_data, XtPointer call_data) {
  XtUnmanageChild(widget);
}


void write_setup(char *filename, Widget widget) {
  Cursor        uhr, pfeil;
  ofstream      dat;
  int           i, j;

  /* A u s g a b e d a t e i   s c h r e i b e n   */
  // cursor setzen;
  uhr  =XCreateFontCursor(XtDisplay(widget),XC_watch);
  pfeil=XCreateFontCursor(XtDisplay(widget), XC_arrow);
  XDefineCursor(XtDisplay(widget),XtWindow(widget),uhr);
  XFlush(XtDisplay(widget));

  // Open File;
  dat.open(filename);
  if (!dat) {
    cout << "Cannot open file for output \n";
    return;
  }

  /* zuerst allgemeine Daten */
  dat << -atof(VERSION) << "\t" << reg.sr << "\t" << reg.length << "\n";
  /* danach Daten fr alle 8 Kanle */
  for (i=0; i<8; i++)  {
    // direct channel;
    dat << i << "\t" << ch[i].active << "\t" << ch[i].polarity << "\t"
	<< ch[i].color << "\t" << ch[i].height << "\n";
    dat << i << "\t" << ch[i].cal.ad_low << "\t" << ch[i].cal.ad_high << "\t"
                     << ch[i].cal.rw_low << "\t" << ch[i].cal.rw_high << "\n";
    // derived channels;
    dat << i << "\t" << dch[i].threshold << "\t" << dch[i].movavg << "\t" << dch[i].ampli << "\n";
    for (j=0; j<7; j++) {
      dat << i << "\t" << j << "\t" << dch[i].ch[j].active << "\t"
	  << dch[i].ch[j].color << "\t" << dch[i].ch[j].height << "\n";
      dat << i << "\t" << j << "\t" << dch[i].ch[j].cal.ad_low << "\t" << dch[i].ch[j].cal.ad_high << "\t"
	  << dch[i].ch[j].cal.rw_low << "\t" << dch[i].ch[j].cal.rw_high << "\n";
    }
  }
  dat.close();
  XDefineCursor(XtDisplay(widget),XtWindow(widget),pfeil);
  XtUnmanageChild(widget);
  XFreeCursor(XtDisplay(widget), pfeil);
  XFreeCursor(XtDisplay(widget), uhr);
  return;
}


void over_setup(Widget w, XtPointer client_data, XtPointer call_data) {

  XmString fname;
  char     *filename;
  XtVaGetValues((Widget)client_data, XmNdirSpec, &fname, NULL);
  XmStringGetLtoR(fname, XmFONTLIST_DEFAULT_TAG, &filename);
  write_setup(filename, (Widget)client_data);
  XmStringFree(fname);
  XtFree(filename);
}

void write_data(char *filename, Widget widget) {
  Cursor        uhr, pfeil;
  int           i, j, isactive, *wert;
  unsigned long *ndata;
  float         m[8], b[8], cumtime;
  char          *fname;
  ofstream      dat, outder[8];
  ifstream      in[8], inder[8];

  uhr  =XCreateFontCursor(XtDisplay(widget),XC_watch);
  pfeil=XCreateFontCursor(XtDisplay(widget), XC_arrow);
  XDefineCursor(XtDisplay(widget),XtWindow(widget),uhr);
  XFlush(XtDisplay(widget));

  wert  = new int;
  ndata = new unsigned long;
  fname = new char [100];

  // open input files;
  isactive=-1;
  for (i=0; i<8; i++) {
    if (ch[i].active) isactive=i;
    sprintf(fname, "out.%d", i);
    in[i].open(fname, ios::in | ios::bin);
    sprintf(fname, "derout.%d", i);
    inder[i].open(fname, ios::in | ios::bin);
  }
  // open output files;
  dat.open(filename);
  if (!dat) {
    cout << "Cannot open file \n";
    return;
  }
  for (i=0; i<8; i++) {
    if (dch[i].nch>0) {
      sprintf(fname, "%s.%d", filename,i);
      outder[i].open(fname);
      if (!outder[i]) {
	cout << "Cannot open file " << fname << "\n";
	return;
      }
    }
  }
  
  // write direkt data;
  for (i=0; i<8; i++) {
    if (ch[i].active) {
      m[i]=(ch[i].cal.rw_high-ch[i].cal.rw_low)/(ch[i].cal.ad_high-ch[i].cal.ad_low);
      b[i]=ch[i].cal.rw_high-(m[i]*ch[i].cal.ad_high);
    }
  }
  if (isactive>=0) {
    *wert=0;
    while(!in[isactive].eof()) {
      for (i=0; i<8; i++) {
	if (ch[i].active) {
	  in[i].read((unsigned char *)wert, 2);
	  dat << m[i] * (float)(*wert) + b[i] << "\t";
	}
      }
      dat << "\n";
    }
  }

  // write derived data;
  *wert=0;
  for (i=0; i<8; i++) {
    if (dch[i].nch>0) {
      cumtime=0;
      while (!inder[i].eof()) {
	inder[i].read((unsigned char *)ndata, sizeof(unsigned long));
	cumtime+=(float)(*ndata)/reg.sr;
	outder[i] << cumtime;
	for (j=0; j<7; j++) {
	  if (dch[i].ch[j].active) {
	    m[j]=(dch[i].ch[j].cal.rw_high-dch[i].ch[j].cal.rw_low)/
	      (dch[i].ch[j].cal.ad_high-dch[i].ch[j].cal.ad_low);
	    b[j]=dch[i].ch[j].cal.rw_high-(m[j]*dch[i].ch[j].cal.ad_high);
	    inder[i].read((unsigned char *)wert, 2);
	    outder[i] << "\t" << m[j] * (float)(*wert) + b[i];
	  }
	}
	outder[i] << "\n";
      }
    }
  }


  delete wert; delete[]fname;
  for (i=0; i<8; i++) {
    in[i].close();
    inder[i].close();
    if (dch[i].nch>0) {
      outder[i].close();
    }
  }
  dat.close();
  XDefineCursor(XtDisplay(widget),XtWindow(widget),pfeil);
  XtUnmanageChild(widget);
  XtSetSensitive(mymenu.file.s_data, False);
  XFreeCursor(XtDisplay(widget), pfeil);
  XFreeCursor(XtDisplay(widget), uhr);
  return;
}

void over_data(Widget w, XtPointer client_data, XtPointer call_data) {
  XmString fname;
  char     *filename;

  XtVaGetValues((Widget)client_data, XmNdirSpec, &fname, NULL);
  XmStringGetLtoR(fname, XmFONTLIST_DEFAULT_TAG, &filename);
  write_data(filename, (Widget)client_data);
  XmStringFree(fname);
  XtFree(filename);
}
