#include <Xm/LabelG.h>
#include <stdio.h>
#include <math.h>
#include "global.h"

#include <time.h>

void showtime(int offset) {
  /* offset = 0 : reset timer to zero            */
  /* offset = 1 : show duration of recording     */
  /* offset = 2 : stop timer                     */
  /* offset = 3 : continue timer                 */
  /* offset = 4 : show recording duration anyway */
  char     mess[255];
           int     t_std, t_min, t_sec;
  static   time_t  initial_zeit, before_zeit;
  unsigned long    delta_zeit;

  switch(offset) {
  case 0:  // reset timer to zero;
    initial_zeit=time(NULL);
    before_zeit=-2*(UPDATE_TIMER);
    break;
  case 1:  // show duration of recording;
    delta_zeit=(unsigned long) (time(NULL)-initial_zeit);
    if (delta_zeit-before_zeit>=UPDATE_TIMER) {
      t_std=(int)(floor(delta_zeit/3600));
      t_min=(int)(floor((delta_zeit-t_std*3600)/60));
      t_sec=(int)(delta_zeit-t_std*3600-t_min*60);
      sprintf(mess,"%.2d:%.2d:%.2d", t_std, t_min, t_sec);
      XtVaSetValues(mess_label,
		    XtVaTypedArg, XmNlabelString, XmRString, mess, strlen(mess)+1,
		    NULL);
      before_zeit=delta_zeit;
    }
    break;
  case 2:   // stop timer;
    before_zeit=time(NULL);
    break;
  case 3:   // continue timer;
    initial_zeit+=(time(NULL)-before_zeit);
    break;
  case 4:   // show recording duration anyway;
    delta_zeit=(unsigned long) (time(NULL)-initial_zeit);
    t_std=(int)(floor(delta_zeit/3600));
    t_min=(int)(floor((delta_zeit-t_std*3600)/60));
    t_sec=(int)(delta_zeit-t_std*3600-t_min*60);
    sprintf(mess,"%.2d:%.2d:%.2d", t_std, t_min, t_sec);
    XtVaSetValues(mess_label,
		  XtVaTypedArg, XmNlabelString, XmRString, mess, strlen(mess)+1,
		  NULL);
    before_zeit=delta_zeit;
    break;
  }
}
